diff --git a/meson.build b/meson.build
index c44d05a13..5c5c09894 100644
--- a/meson.build
+++ b/meson.build
@@ -671,6 +671,8 @@ endif
 
 if get_option('xkbcommon').auto() and not have_system and not have_tools
   xkbcommon = not_found
+elif get_option('xkbcommon').disabled()
+  xkbcommon = not_found
 else
   xkbcommon = dependency('xkbcommon', required: get_option('xkbcommon'),
                          method: 'pkg-config', kwargs: static_kwargs)
diff --git a/pc-bios/keymaps/meson.build b/pc-bios/keymaps/meson.build
index 158a3b410..3bb318a23 100644
--- a/pc-bios/keymaps/meson.build
+++ b/pc-bios/keymaps/meson.build
@@ -33,8 +33,10 @@ keymaps = {
   'tr': '-l tr',
 }
 
-if meson.is_cross_build() or not xkbcommon.found()
+if meson.is_cross_build()
   native_qemu_keymap = find_program('qemu-keymap', required: false, disabler: true)
+elif get_option('xkbcommon').disabled()
+  native_qemu_keymap = not_found
 else
   native_qemu_keymap = qemu_keymap
 endif
